package com.sa.ibiz.demo.demoapp.controller.demo.vo;

import java.sql.Timestamp;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import lombok.Data;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.demo.domain.UserRoleRes;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import java.util.Map;
import java.util.Date;
import org.springframework.cglib.beans.BeanCopier;
import javax.validation.constraints.Size;
import java.util.UUID;
import org.springframework.cglib.beans.BeanCopier;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.math.BigInteger;
import com.alibaba.fastjson.JSONObject;

@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class UserRoleRes_EditForm_Main2{

    @JsonProperty(access=Access.WRITE_ONLY)
    private Map<String,String> srfparentdata;
    @JsonIgnore
    private Timestamp updatedate;
    @JsonProperty(access=Access.WRITE_ONLY)
    private String srforikey;
    @JsonIgnore
    private String userroleresid;
    @JsonIgnore
    private String userroleresname;
    @JsonIgnore
    private String srftempmode;
    @JsonProperty
    private String srfuf;
    @JsonProperty
    private String srfdeid;
    @JsonProperty(access=Access.WRITE_ONLY)
    private String srfsourcekey;
    @JsonIgnore
    private String userrolename;
    @JsonIgnore
    private String uniresname;
    @JsonIgnore
    private Integer isallow;
    @JsonIgnore
    private String createman;
    @JsonIgnore
    private Timestamp createdate;
    @JsonIgnore
    private String updateman;
    @JsonIgnore
    private String uniresid;
    @JsonIgnore
    private String userroleid;

    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JsonProperty(value = "srfupdatedate")
    public Timestamp getSrfupdatedate(){
        return updatedate;
    }
    @JsonProperty(value = "srfupdatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    public void setSrfupdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
    }

    @JsonProperty(value = "srforikey")
    public String getSrforikey(){
        return srforikey;
    }
    @JsonProperty(value = "srforikey")
    public void setSrforikey(String srforikey){
        this.srforikey = srforikey;
    }

    @Size(min = 0, max = 100, message = "[用户角色资源能力标识]长度必须在[100]以内!")
    @JsonProperty(value = "srfkey")
    public String getSrfkey(){
        return userroleresid;
    }
    @JsonProperty(value = "srfkey")
    public void setSrfkey(String userroleresid){
        this.userroleresid = userroleresid;
    }

    @Size(min = 0, max = 200, message = "[用户角色资源能力名称]长度必须在[200]以内!")
    @JsonProperty(value = "srfmajortext")
    public String getSrfmajortext(){
        return userroleresname;
    }

    @JsonProperty(value = "srftempmode")
    public String getSrftempmode(){
        return srftempmode;
    }
    @JsonProperty(value = "srftempmode")
    public void setSrftempmode(String srftempmode){
        this.srftempmode = srftempmode;
    }

    @JsonProperty(value = "srfdeid")
    public String getSrfdeid(){
        return srfdeid;
    }
    @JsonProperty(value = "srfdeid")
    public void setSrfdeid(String srfdeid){
        this.srfdeid = srfdeid;
    }

    @NotBlank(message = "[用户角色]不允许为空!")
    @Size(min = 0, max = 200, message = "[用户角色]长度必须在[200]以内!")
    @JsonProperty(value = "userrolename")
    public String getUserrolename(){
        return userrolename;
    }
    @JsonProperty(value = "userrolename")
    public void setUserrolename(String userrolename){
        this.userrolename = userrolename;
    }

    @NotBlank(message = "[资源]不允许为空!")
    @Size(min = 0, max = 200, message = "[资源]长度必须在[200]以内!")
    @JsonProperty(value = "uniresname")
    public String getUniresname(){
        return uniresname;
    }
    @JsonProperty(value = "uniresname")
    public void setUniresname(String uniresname){
        this.uniresname = uniresname;
    }

    @NotNull(message = "[允许模式]不允许为空!")
    @JsonProperty(value = "isallow")
    public Integer getIsallow(){
        return isallow;
    }
    @JsonProperty(value = "isallow")
    public void setIsallow(Integer isallow){
        this.isallow = isallow;
    }

    @Size(min = 0, max = 60, message = "[建立人]长度必须在[60]以内!")
    @JsonProperty(value = "createman")
    public String getCreateman(){
        return createman;
    }
    @JsonProperty(value = "createman")
    public void setCreateman(String createman){
        this.createman = createman;
    }

    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JsonProperty(value = "createdate")
    public Timestamp getCreatedate(){
        return createdate;
    }
    @JsonProperty(value = "createdate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
    }

    @Size(min = 0, max = 60, message = "[更新人]长度必须在[60]以内!")
    @JsonProperty(value = "updateman")
    public String getUpdateman(){
        return updateman;
    }
    @JsonProperty(value = "updateman")
    public void setUpdateman(String updateman){
        this.updateman = updateman;
    }

    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JsonProperty(value = "updatedate")
    public Timestamp getUpdatedate(){
        return updatedate;
    }
    @JsonProperty(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
    }

    @Size(min = 0, max = 100, message = "[用户角色资源能力标识]长度必须在[100]以内!")
    @JsonProperty(value = "userroleresid")
    public String getUserroleresid(){
        return userroleresid;
    }
    @JsonProperty(value = "userroleresid")
    public void setUserroleresid(String userroleresid){
        this.userroleresid = userroleresid;
    }

    @Size(min = 0, max = 100, message = "[统一资源]长度必须在[100]以内!")
    @JsonProperty(value = "uniresid")
    public String getUniresid(){
        //输出获取外键值方法-用于通过parentdata关系填充外键值id
        if(StringUtils.isEmpty(uniresid) && this.getSrfparentdata() != null)
        {
            if(this.getSrfparentdata().containsKey("srfparentmode")&& this.getSrfparentdata().get("srfparentmode").equals("DER1N_USERROLERES_UNIRES_UNIRESID"))
                this.uniresid=this.getSrfparentdata().get("srfparentkey");
        }
        return uniresid;
    }
    @JsonProperty(value = "uniresid")
    public void setUniresid(String uniresid){
        this.uniresid = uniresid;
    }

    @Size(min = 0, max = 100, message = "[用户角色]长度必须在[100]以内!")
    @JsonProperty(value = "userroleid")
    public String getUserroleid(){
        //输出获取外键值方法-用于通过parentdata关系填充外键值id
        if(StringUtils.isEmpty(userroleid) && this.getSrfparentdata() != null)
        {
            if(this.getSrfparentdata().containsKey("srfparentmode")&& this.getSrfparentdata().get("srfparentmode").equals("DER1N_USERROLERES_USERROLE_USERROLEID"))
                this.userroleid=this.getSrfparentdata().get("srfparentkey");
        }
        return userroleid;
    }
    @JsonProperty(value = "userroleid")
    public void setUserroleid(String userroleid){
        this.userroleid = userroleid;
    }

    public  void fromUserRoleRes(UserRoleRes sourceEntity)  {
        this.fromUserRoleRes(sourceEntity,true);
    }

     /**
	 * do转换为vo
	 * @param sourceEntity do数据对象
	 * @return
	 */
    public  void fromUserRoleRes(UserRoleRes sourceEntity,boolean reset)  {
      BeanCopier copier=BeanCopier.create(UserRoleRes.class, UserRoleRes_EditForm_Main2.class, false);
      copier.copy(sourceEntity,this,  null);
      this.toString();
	}

    /**
	 * vo转换为do
	 * @param
	 * @return
	 */
    public  UserRoleRes toUserRoleRes()  {
        UserRoleRes targetEntity =new UserRoleRes();
        BeanCopier copier=BeanCopier.create(UserRoleRes_EditForm_Main2.class, UserRoleRes.class, false);
        copier.copy(this, targetEntity, null);
        return targetEntity;
	}

     /**
	 * 新建
	 * @param
	 * @return
	 */
    private boolean isCreate()
    {
    	if((StringUtils.isEmpty(this.srfuf))||this.srfuf.equals("0"))
	    	return true;
    	else
    	    return false;
    }
     /**
	 * 更新
	 * @param
	 * @return
	 */
    private boolean isUpdate()
    {
    	if((!StringUtils.isEmpty(this.srfuf))&&this.srfuf.equals("1"))
	    	return true;
    	else
    	    return false;
    }

}
